//******************************************************************************
//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// This code numerically computes the Cramer-Rao bound for the variance of
// the frequency offset estimate.
// Code tested on SCILAB ver 5.3.3.
//******************************************************************************
clear;
timer();
//******************************************************************************
PRE_AMB_SIZE=512;                                     // Length of the preamble.
CHAN_MEM=9;                                         // Length of channel memory.
CHAN_LEN=CHAN_MEM+1;                                       // Length of channel.
FOFF_EST_RX_SIZE=PRE_AMB_SIZE+CHAN_LEN-1;     // Size of rx. vec. for freq. est.
FADE_VAR=0.5;                               // Variance per dimension of fading.
Pav=2.0;                                // Avg. power of the QPSK constellation.
Rx_Sig_Var=FADE_VAR*CHAN_LEN*Pav/FOFF_EST_RX_SIZE;       // Power of tx. signal.
ERROR=0.000001;
//******************************************************************************
k=[1:FOFF_EST_RX_SIZE];
k_sq=k.^2;
//******************************************************************************
for i=1:FOFF_EST_RX_SIZE
 pole= -1.0/(2*i^2*Rx_Sig_Var);
 Res=1.0+2.0*pole*k_sq*Rx_Sig_Var;
 [Loc_Zero]=find(abs(Res)<ERROR);
 Res(Loc_Zero)=1.0;
 pause;
end;
timer
//******************************************************************************
