//******************************************************************************
//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// This code computes sum_{n=1}^N |x_n|^2 n^2 and compares it with
// E[|x_n|^2] sum_{n=1}^N n^2. If x_n is ergodic, the two sums must be nearly
// equal.
// Code tested on SCILAB ver 5.3.3.
//******************************************************************************
clear;
timer();
//******************************************************************************
PRE_AMB_SIZE=512;                                     // Length of the preamble.
CHAN_MEM=9;                                         // Length of channel memory.
CHAN_LEN=CHAN_MEM+1;                                       // Length of channel.
FOFF_EST_RX_SIZE=PRE_AMB_SIZE-CHAN_LEN+1;     // Size of rx. vec. for freq. est.
FADE_VAR=0.5;                               // Variance per dimension of fading.
Pav=2.0;                                // Avg. power of the QPSK constellation.
//******************************************************************************
FADE_MEAN=0.0;                                                // Mean of fading.
FADE_VAR=0.5;                               // Variance per dimension of fading.
FADE_STD=sqrt(FADE_VAR);                            // Std. deviation of fading.
//******************************************************************************
A=[1:FOFF_EST_RX_SIZE];
Re_Fade=grand(A,'nor',FADE_MEAN,FADE_STD);
Im_Fade=grand(A,'nor',FADE_MEAN,FADE_STD);
Fade=Re_Fade+%i*Im_Fade;
B=(A.^2).*abs(Fade).^2;
sum_rand=sum(B);
sum_int=sum(A.^2);
P_Error=100.0*(sum_rand-sum_int)/sum_int;
//******************************************************************************
timer
//******************************************************************************
