//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// Get coded QPSK symbols. Data goes to real part, parity goes to the
// imaginary part.
// Code tested on SCILAB ver 5.3.3.
//******************************************************************************
function[Coded_Tx_Sym]=Get_Coded_QPSK(my_size,gen_vec,div_map)
 re_sym=int(2*grand(1,my_size,'def'));
 iv_sym=re_sym(div_map(:));                                       // Row vector.
 parity1=round(convol(gen_vec,re_sym));
 parity2=round(convol(gen_vec,iv_sym));
 parity1=modulo(parity1(1:my_size),2);
 parity2=modulo(parity2(1:my_size),2);
 re_sym=1-2*re_sym;                                          // Data: 1, -1 seq.
 parity1=1-2*parity1;                                      // Parity: 1, -1 seq.
 iv_sym=1-2*iv_sym;                                      // Iv. data: 1, -1 seq.
 parity2=1-2*parity2;                                      // Parity: 1, -1 seq.
 Coded_Tx_Sym=[re_sym+%i*parity1 iv_sym+%i*parity2];    // Data: re; parity: im.
endfunction
