//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// Get the super trellis.
// Code tested on SCILAB ver 6.0 beta 2.
//******************************************************************************
function[N_S_State,P_S_State,P_S_Ip,Ga_S_Inx,Gb_S_Inx]=Get_S_Trellis()
 N_S_State=zeros(NUM_S_STATES,MOD_NUM_INPUTS);
 P_S_State=zeros(NUM_S_STATES,MOD_NUM_INPUTS);
 P_S_Ip=zeros(NUM_S_STATES,MOD_NUM_INPUTS);
 Ga_S_Inx=zeros(NUM_S_STATES,MOD_NUM_INPUTS);
 Gb_S_Inx=zeros(NUM_S_STATES,MOD_NUM_INPUTS);
 for state=1:NUM_S_STATES
  st_inx(state)=1;
 end
 for state=0:NUM_S_STATES-1
  for ip=0:MOD_NUM_INPUTS-1
   state1=int(state/NUM_STATES)+1;              // Most significant digit (tx1).
   state2=modulo(state,NUM_STATES)+1;          // Least significant digit (tx2).
   input1=int(ip/NUM_INPUTS)+1;                   // Most significant bit (tx1).
   input2=modulo(ip,NUM_INPUTS)+1;               // Least significant bit (tx2).
   nstate1=N_State(state1,input1);
   nstate2=N_State(state2,input2);
   op1=Gb_Inx(state1,input1);                   // Most significant digit (tx1).
   op2=Gb_Inx(state2,input2);                  // Least significant digit (tx2).
   n_st=(nstate1-1)*NUM_STATES+nstate2-1+1;
   N_S_State(state+1,ip+1)=n_st;
   P_S_Ip(n_st,st_inx(n_st))=ip+1;
   P_S_State(n_st,st_inx(n_st))=state+1;
   Ga_S_Inx(n_st,st_inx(n_st))=(op1-1)*CONSTELL_SIZE+op2-1+1;
   Gb_S_Inx(state+1,ip+1)=(op1-1)*CONSTELL_SIZE+op2-1+1;
   st_inx(n_st)=st_inx(n_st)+1;
  end
 end
endfunction
