//******************************************************************************
//******************************************************************************
//*   Copyright (C) 2016 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// This code computes the average error rates (coded BER, uncoded BER and
// probability of erasure). Note that the "*_avg.txt" files have only one
// line containing the average value.
// Code tested on SCILAB ver 5.5.2.
//******************************************************************************
// Open files for reading.
//******************************************************************************
SNR_DB=2.5;                                               // SNR per bit in dB.
x=string(SNR_DB);
y = strsubst(x, '.', '_');
fd_u_ber_w = mopen(pwd()+'/u_ber_'+y+'.txt', 'rt');         // Uncoded BER file.
fd_c_ber_w = mopen(pwd()+'/c_ber_'+y+'.txt', 'rt');           // Coded BER file.
fd_f_eer_w = mopen(pwd()+'/f_eer_'+y+'.txt', 'rt');             // Erasure file.
//******************************************************************************
// Read the files.
//******************************************************************************
u_ber_w_mat=mfscanf(-1,fd_u_ber_w,'%f %f');
c_ber_w_mat=mfscanf(-1,fd_c_ber_w,'%f %f');
f_eer_w_mat=mfscanf(-1,fd_f_eer_w,'%f %f');
//******************************************************************************
// Open files for writing.
//******************************************************************************
fd_u_ber_avg=mopen(pwd()+'/u_ber_'+y+'_avg.txt','wt'); // Avg. uncoded BER file.
fd_c_ber_avg=mopen(pwd()+'/c_ber_'+y+'_avg.txt','wt');   // Avg. coded BER file.
fd_f_eer_avg=mopen(pwd()+'/f_eer_'+y+'_avg.txt','wt');     // Avg. erasure file.
//******************************************************************************
// Compute the average error rates.
//******************************************************************************
u_ber_avg=mean(u_ber_w_mat,'r');                            // Avg. uncoded BER.
c_ber_avg=mean(c_ber_w_mat,'r');                              // Avg. coded BER.
f_eer_avg=mean(f_eer_w_mat,'r');                                // Avg. erasure.
//******************************************************************************
// Write the average values into the files.
//******************************************************************************
mfprintf(fd_u_ber_avg,'%f %.10f\n',SNR_DB,u_ber_avg(1,2));
mfprintf(fd_c_ber_avg,'%f %.10f\n',SNR_DB,c_ber_avg(1,2));
mfprintf(fd_f_eer_avg,'%f %.10f\n',SNR_DB,f_eer_avg(1,2));
//******************************************************************************
// Close the files.
//******************************************************************************
mclose(fd_u_ber_w);
mclose(fd_c_ber_w);
mclose(fd_f_eer_w);
mclose(fd_u_ber_avg);
mclose(fd_c_ber_avg);
mclose(fd_f_eer_avg);
//******************************************************************************
