#*******************************************************************************
#    Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the bit error rates for uncoded OFDM with no frequency offset.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "uc_qpsk.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "uc_qpsk.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key left bottom box
#set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%2.1e"
set output "dmt_no_foff.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "dmt4_estch_o4096_p512.dat" t\
     "LS, L_p=512"\
      w linespoints lt -1 lw 1 pt 1,\
     "dmt4_estch_o4096_p256.dat" t\
     "LS, L_p=256"\
      w linespoints lt -1 lw 1 pt 2,\
     "dmt4_estch_o4096_p128.dat" t\
     "LS, L_p=128"\
      w linespoints lt -1 lw 1 pt 3,\
     "dmt4_estch_o4096_p64.dat" t\
     "LS, L_p=64"\
      w linespoints lt -1 lw 1 pt 4,\
     "dmt4_idlch_o4096_p512.dat" t\
     "ideal ch est, sync"\
      w linespoints lt -1 lw 1 pt 5
