//******************************************************************************
//*   Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
//*   All Rights Reserved.
//******************************************************************************
// Get the trellis. State convention: Input side is MSB.
// Code tested on SCILAB ver 5.3.2.
//******************************************************************************
function[N_State,P_State,P_Ip,Op]=Get_Trellis(nc,dc,numip,numst,nmem)
 N_State=zeros(numst,numip);
 P_State=zeros(numst,numip);
 P_Ip=zeros(numst,numip);
 Op=zeros(numst,numip);
 for state=1:numst
  st_inx(state)=1;
 end
 for state=0:numst-1
  for ip=0:numip-1
   y=strtod(strsplit(dec2bin(state,nmem)));                  // State in binary.
   y0=ip;
   for i=1:nmem
    y0=bitxor(y0,y(i)*dc(i+1));
   end
   t_op=y0*nc(1);
   for i=1:nmem
    t_op=bitxor(t_op,y(i)*nc(i+1));
   end
   Op(state+1,ip+1)=t_op;
   for i=nmem:-1:2
    y(i)=y(i-1);
   end
   y(1)=y0;
   n_st=bin2dec(strcat(string(y)))+1;
   N_State(state+1,ip+1)=n_st;
   P_State(n_st,st_inx(n_st))=state+1;
   P_Ip(n_st,st_inx(n_st))=ip+1;
   st_inx(n_st)=st_inx(n_st)+1;
  end
 end
endfunction
