#*******************************************************************************
#    Copyright (C) 2016 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the bit error rates for turbo coded OFDM with estimated
# channel, frequency offset and timing. Data + postamble interleaving is done.
# Postamble is used to detect the residual frequency offset. Postamble size
# is 256 QPSK symbols. Code rate is unity. 2nd order diversity at the
# receiver.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "dmt33_ber.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "dmt33_ber.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key left bottom box
#set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%2.1e"
set output "dmt33_ber.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "../dmt33_e/dmt33_e_cber_ip16.dat" t\
     "Lp=512, Lo=256, Pr"\
      w linespoints lt 1 lw 4 pt 1 ps 2,\
     "../dmt33_i/dmt33_i_cber_ip16.dat" t\
     "Id"\
      w linespoints lt 8 lw 4 pt 6 ps 2,\
     "../dmt36_e/dmt36_e_cber_ip16.dat" t\
     "Lp=1024, Lo=512, Pr"\
      w linespoints lt 2 lw 4 pt 2 ps 2
