#*******************************************************************************
#    Copyright (C) 2011 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the probability of frame erasure for uncoded OFDM with estimated
# channel and timing. Frequency offset is assumed to be zero.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "dmt4_erase.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "dmt4_erase.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key center bottom width 1 box
#set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%2.1e"
set output "dmt4_erase.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "../dmt4/dmt4_estch_o4096_p64_erase.dat" t\
     "Lp=64"\
      w linespoints lt 1 lw 4 pt 1 ps 2,\
     "../dmt4/dmt4_estch_o4096_p128_erase.dat" t\
     "Lp=128"\
      w linespoints lt 3 lw 4 pt 2 ps 2,\
     "../dmt4/dmt4_estch_o4096_p256_erase.dat" t\
     "Lp=256"\
      w linespoints lt 4 lw 4 pt 3 ps 2
